/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2010 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *******************************************************************************
 *
 * $Id: AsLookup.java,v 1c263a6d8ac9 2010/02/14 00:23:33 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.openrdf.elmo.impl;

import it.tidalwave.openrdf.elmo.ElmoAsSupport;
import it.tidalwave.util.As.NotFoundBehaviour;
import javax.annotation.Nonnull;
import java.util.Collection;
import java.util.Collections;
import javax.annotation.CheckForNull;
import org.openide.util.Lookup;
import org.openide.util.LookupListener;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: AsLookup.java,v 1c263a6d8ac9 2010/02/14 00:23:33 fabrizio $
 *
 ******************************************************************************/
public class AsLookup extends Lookup
  {
//    private static final String CLASS = MixinLookup.class.getName();
//    private static final Logger logger = Logger.getLogger(CLASS);
//
    @Nonnull
    private final Object owner;

    /***************************************************************************
     *
     *
     **************************************************************************/
    public AsLookup (@Nonnull final Object owner)
      {
        this.owner = owner;
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Override
    @CheckForNull
    public <T> T lookup (@Nonnull final Class<T> clazz)
      {
        return ElmoAsSupport.as(owner, clazz, new NotFoundBehaviour<T>()
          {
            public T run (@Nonnull final Throwable t)
              {
                return null;
              }
          });
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Override
    public <T> Result<T> lookup (final Template<T> template)
      {
        return new Result<T>()
          {
            @Override
            public void addLookupListener (LookupListener listener)
              {
              }

            @Override
            public void removeLookupListener (LookupListener listener)
              {
              }

            @Override
            public Collection<? extends T> allInstances()
              {
                return Collections.singletonList(lookup(template.getType()));
              }
          };
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Override
    @Nonnull
    public String toString()
      {
        return String.format("AsLookup@%x", System.identityHashCode(this));
      }
  }
